require 'cgi'

class String
	def wikify()
		string = self
		string.gsub!(/[\n
]\s?[\n
]/,"¶")
		links = string.scan(/_.+?_ <.+?>/)
		uris = [ ]
		links.each do |link|
			uris << %{<a href="#{link.scan(/<.+?>/)[0].gsub(/[<>]/,"")}">#{link.scan(/_.+?_/)[0].gsub(/[_]/,"")}</a>}
			string.gsub!(link,"::LINK#{uris.size - 1}::")
		end
		links = string.scan(%r{http://.+? })
		links.each do |link|
			uris << %{<a href="#{link.gsub(/ $/,"")}">#{link.gsub(/ $/,"")}</a>}
			string.gsub!(link,"::LINK#{uris.size - 1}:: ")
		end
		dates = string.scan(%r{\d+/\d+/\d\d+})
		dates.each do |date|
			string.gsub!(date, date.gsub("/","&#047;"))
		end
		if block_given?:
			links = string.scan("\[.+?\]")
			links.each do |link|
				url = yield link
				uris << %{<a href="#{url}">#{link}</a>}
				string.gsub!(link,"::LINK#{uris.size - 1}::")
			end
		end
		string = CGI.escapeHTML(string)
		string.scan(/&amp;.+?;/).each { |entity| string.gsub!(entity,entity.gsub("&amp;","&")) }
		string.gsub!(/----+/,"<hr/>")
		string.gsub!("--","—")
		string.scan(%r{/.+?/}).each { |emphasis| string.gsub!(emphasis,emphasis.gsub(%r{^/},"<em>").gsub(%r{/$},"</em>")) }
		string.scan(/-.+?-/).each { |strong| string.gsub!(strong,strong.gsub(/^-/,"<strong>").gsub(/-$/,"</strong>")) }
		string.scan(%r{<p><strong>.+?</strong></p>}).each { |heading| string.gsub!(heading,heading.gsub("<p><strong>","<h3>").gsub("</strong></p>","</h3>")) }
		words = string.split
		em = false
		strong = false
		eminstrong = false
		stronginem = false
		0.upto(words.size - 1) do |i|
			if words[i] =~ /<strong><em>.+/:
				eminstrong = true
			elsif words[i] =~ /<em><strong>.+/:
				stronginem = true
			elsif words[i] =~ /<em>.+/:
				em = true
				if strong then eminstrong = true end
			elsif words[i] =~ /<strong>.+/:
				strong = true
				if em then stronginem = true end
			end
			if stronginem:
				words[i].gsub!("</em></strong>","</strong></em>")
				unless words[i] =~ %r{</strong></em>}:
					words[i].gsub!("</em>","</strong></em><strong>")
				end
			end
			if eminstrong:
				words[i].gsub!("</strong></em>","</em></strong>")
				unless words[i] =~ %r{</em></strong>}:
					words[i].gsub!("</strong>","</em></strong><em>")
				end
			end
			if words[i] =~ /.+<\/strong><\/em>/:
				stronginem = false
				em = false
			elsif words[i] =~ /.+<\/em><\/strong>/:
				eminstrong = false
				strong = false
			elsif words[i] =~ /.+<\/em>/:
				em = false
				stronginem = false
			elsif words[i] =~ /.+<\/strong>/:
				strong = false
				eminstrong = false
			end
			words[i].gsub!("<</em>strong>","</strong>")
			words[i].gsub!("<</em>a>","</a>")
			words[i].gsub!("<</em>em>","</em>")
		end
		string = words.join(" ")
		0.upto(uris.size - 1) { |i| string.gsub!("::LINK#{i}::",uris[i]) }
		string.gsub!("¶","</p><p>")
		return "<p>#{string}</p>"
	end
end
